package com.codeandvisual.integrations.gpt {
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.net.URLRequestHeader;
	import flash.net.URLRequestMethod;
	
	public class OpenAIDemo {
		public static var key:String
		public static var endpoint:String
		public static var model:String
		public static var temperature:Number
		public static var callback:Function
		public function OpenAIDemo():void {
		
		}
		
		public static function init(thisKey:String, thisTemperature:Number = 0.7, thisEndPoint:String = "https://api.openai.com/v1/chat/completions", thisModel:String = "gpt-3.5-turbo"):void {
			key = thisKey
			temperature = thisTemperature
			endpoint = thisEndPoint
			model = thisModel
		}
		
		public static function getResponse(thisInput:String ,thisCallback:Function, thisTemperature:Number = NaN, thisEndPoint:String = "", thisModel:String = ""):void {
			callback = thisCallback
			var myTemperature:Number = isNaN(thisTemperature) ? temperature : thisTemperature;
			var myEndPoint:String = thisEndPoint == "" ? endpoint : thisEndPoint;
			var myModel:String = thisModel == "" ? model : thisModel;
			var myHeaders:Array = [];
			myHeaders.push(new URLRequestHeader("Content-Type", "application/json"));
			myHeaders.push(new URLRequestHeader("Authorization", "Bearer " + key));
			//
			var myVariables:Object = {}
			myVariables["model"] = model;
			myVariables["messages"] = [{"role": "user", "content": thisInput}];
			myVariables["temperature"] = myTemperature;
			var myLoader:URLLoader = post(myEndPoint, JSON.stringify(myVariables), myHeaders)
		}
		
		public static function post(thisPath:String, thisJSONData:String, thisHeaders:Array ):URLLoader {
			//
			// -----------------------------------------------------------
			// Create Loader
			// -----------------------------------------------------------
			var myLoader:URLLoader =  new URLLoader();
			var myRequest:URLRequest
			myRequest = new URLRequest(thisPath);
			myRequest.method = URLRequestMethod.POST;
			myRequest.requestHeaders = thisHeaders
			myRequest.data = thisJSONData;
			//
			// -----------------------------------------------------------
			// Add Listeners
			// -----------------------------------------------------------
			
			myLoader.addEventListener(IOErrorEvent.IO_ERROR, doError);
			myLoader.addEventListener(Event.COMPLETE, doSuccess);
			
			//
			// -----------------------------------------------------------
			// Send Request
			// -----------------------------------------------------------
			myLoader.load(myRequest);
			return myLoader
		}
		
		public static function doSuccess(e:Event):void {
			var myLoader:URLLoader = e.currentTarget as URLLoader
			removeListeners(myLoader)
			var myData:String = myLoader.data
			var myObject:Object = JSON.parse(myData)
			trace("OpenAI - Response Success")
			callback(myObject);
			callback = null
		}
		
		public static function doError(e:IOErrorEvent):void {
			var myLoader:URLLoader = e.currentTarget as URLLoader
			removeListeners(myLoader)
			trace("OpenAI - Response Fail: " + myLoader.data)
			callback = null
		}
		
		public static function removeListeners(thisLoader:URLLoader):void {
			thisLoader.removeEventListener(IOErrorEvent.IO_ERROR, doError);
			thisLoader.removeEventListener(Event.COMPLETE, doSuccess);
		}
	}
}